#ifndef _BBOX_
#define _BBOX_

#   include <cprec.h>
#   include <const.h>
#   include <cmath>
#   include <iostream>
#   include <fstream>
#   include <interval.h>

#   define HIGHAR 1.e-4

/** Bounding boxes around 3-dimensional geometries */

    class cBbox
   {
       protected:

          bool            empty;                                     /**<Indicate whether the box is empty or not.
                                                                         True as soon as the box is instantiated.
                                                                         False as soon as it reaches finite size. **/

          Int             nx;                                        /**<Number of coordinates. **/

          Real            x0[3];                                     /**<Lower left corner.**/
          Real            x1[3];                                     /**<Top right corner.**/

       public:
          cBbox();
         ~cBbox()
         {
             #pragma acc exit data delete(this)
         };

          virtual void setCorners( Int n, Real *x );
          virtual void setCorners( Int ips, Int ipe, Int n, Real *x[] );
          virtual void setCorners( Int, Int, Int *[], Int, Real *[] );
          virtual void resetCorners( );
          virtual void print();
          virtual Real area( cBbox *data );
          virtual Real length();
          virtual Real minlength();
          virtual Real area();
          virtual bool inside( Real x[] );
          virtual bool inside( cBbox *data );
          virtual void add( cBbox *data );
          virtual void grow( Real data );
   };

      bool bintrsct( cBbox *box1, cBbox *box2 );
      bool boverlap( cBbox *box1, cBbox *box2 );
#endif
